package lel.flummi.skilloverlay.api.records;

import java.util.HashMap;
import java.util.List;

import lel.flummi.skilloverlay.utils.SkillInfo;

public record Skills(
		HashMap<String, Skill> skills) {
	public record Skill(
			String name,
			int maxLevel,
			List<Level> levels) {
		public record Level(
				int level,
				float totalExpRequired) {
		}

		public SkillInfo getLevel(float exp) {
			int aktLevel = 0;

			for (Level tmp : this.levels()) {
				if (exp < tmp.totalExpRequired) {
					// int level, float totalXp, float currentXp, float currentXpMax
					return new SkillInfo(aktLevel, tmp.totalExpRequired, exp, tmp.totalExpRequired);
				}
				aktLevel = tmp.level;
			}

			return null;
		}

	}
}
